#lang racket

(define f (lambda (x y z) (+ (* 5 x) (* 4 y) (* 3 z))))

(define fc (lambda (x) 
             (lambda (y) ; x is free in this lambda
               (lambda (z) (+ (* 5 x) (* 4 y) (* 3 z)))))) ; x, y are free in this lambda
 
(f 4 5 6)
 
(((fc 4) 5) 6)
 
(define g (fc 4))      ; partial application
 
(define h ((fc 4) 5))  ; partial application

; curry f as a function of 2 variables returning a function of 1 variable
(define fc2to1 (lambda (x y)
                 (lambda (z) (+ (* 5 x) (* 4 y) (* 3 z)))))

(define h1 (fc2to1 4 5))
(h1 6)
((fc2to1 4 5) 6)

; curry f as a function of 1 variable returning a function of 2 variables
(define fc1to2 (lambda (x)
                 (lambda (y z) (+ (* 5 x) (* 4 y) (* 3 z)))))

(define h2 (fc1to2 4))
(h2 5 6)
((fc1to2 4) 5 6)
