
// Partially apply a function of two parameters to the given value.
partial2to1 = (f, x) => y => f(x, y);

// Partially apply a function of three parameters to the given value.
partial3to2 = (f, x) => (y, z) => f(x, y, z);

// Partially apply a function of four parameters to the given value.
partial4to3 = (f, x) => (y, z, w) => f(x, y, z, w);

// Partially apply a function of three parameters to the given two values.
partial3to1 = (f, x, y) => z => f(x, y, z);

// Return a curried version of a function of two parameters.
curried2 = f => x => y => f(x, y);

// Return a curried version of a function of three parameters.
curried3 = f => x => curried2(partial3to2(f, x));

// Return a curried version of a function of four parameters.
curried4 = f => x => curried3(partial4to3(f, x));

f = (x, y, z, w) => x + y + z + w;
fc = curried4(f);
f7 = fc(7);
f75 = f7(5);
alert( f75(1)(2) );  // prints f(7,5,1,2) ==> 15
